﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Telerik.Windows.Controls;

namespace ComboBoxMultipleSelectionWrapping
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void _radComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var comboBox = sender as RadComboBox;
            var popup = comboBox.ChildrenOfType<Popup>().FirstOrDefault();
            if (popup != null)
            {
                Dispatcher.BeginInvoke((Action)(() => {
                    popup.VerticalOffset -= 1;
                    popup.VerticalOffset += 1;
                }), DispatcherPriority.ApplicationIdle);
            }
        }
    }

    public class Car
    {
        public string Make { get; set; }
        public string Model { get; set; }

        public Car(string make, string model)
        {
            this.Make = make;
            this.Model = model;
        }
    }

    public class MyViewModel
    {
        private ObservableCollection<Car> cars;

        public ObservableCollection<Car> Cars
        {
            get
            {
                if (this.cars == null)
                {
                    this.cars = this.CreateCars();
                }
                return this.cars;
            }
        }

        private ObservableCollection<Car> CreateCars()
        {
            ObservableCollection<Car> cars = new ObservableCollection<Car>()
        {
            new Car("Opel", "Vectra"),
            new Car("Ford", "Focus"),
            new Car("Fiat", "Bravo"),
            new Car("Subaru", "Impreza"),
            new Car("Mercedes-Benz", "C-Class"),
            new Car("Fiat", "Bravo"),
        };
            return cars;
        }
    }
}
